<?php declare(strict_types=1);

namespace Drupal\group_clone;

use Drupal\Core\Plugin\DefaultPluginManager;
use Drupal\Core\Cache\CacheBackendInterface;
use Drupal\Core\Extension\ModuleHandlerInterface;

final class GroupContentClonerManager extends DefaultPluginManager {

  /**
   * Constructs a new class instance.
   */
  public function __construct(
    \Traversable $namespaces,
    CacheBackendInterface $cache_backend,
    ModuleHandlerInterface $module_handler
  ) {
    parent::__construct('Plugin/GroupContentCloner', $namespaces, $module_handler, 'Drupal\group_clone\Plugin\GroupContentCloner\GroupContentClonerInterface', 'Drupal\group_clone\Annotation\GroupContentCloner');
    $this->alterInfo('group_content_cloner');
    $this->setCacheBackend($cache_backend, 'group_content_cloner');
  }

  /**
   * Gets the plugin definitions for this group content base plugin ID.
   *
   * @return mixed[]
   */
  public function getDefinitionsByPlugin(string $plugin_id): array {
    return \array_filter($this->getDefinitions(), function ($definition) use ($plugin_id) {
      return $definition['content_plugin_id'] === $plugin_id;
    });
  }

}
