<?php declare(strict_types=1);

namespace Drupal\group_clone\Plugin\GroupContentCloner;

use Drupal\Core\Entity\EntityTypeManagerInterface;
use Drupal\Core\Plugin\PluginBase;
use Drupal\Core\Plugin\ContainerFactoryPluginInterface;
use Drupal\group\Entity\GroupContentInterface;
use Drupal\group_clone\EntityCloneTrait;
use Symfony\Component\DependencyInjection\ContainerInterface;

abstract class GroupContentClonerBase extends PluginBase implements GroupContentClonerInterface, ContainerFactoryPluginInterface {

  use EntityCloneTrait;

  protected EntityTypeManagerInterface $entityTypeManager;

  /**
   * Constructs a new instance.
   */
  public function __construct(
    array $configuration,
    string $plugin_id,
    array $plugin_definition,
    EntityTypeManagerInterface $entity_type_manager
  ) {
    parent::__construct($configuration, $plugin_id, $plugin_definition);

    $this->entityTypeManager = $entity_type_manager;
  }

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container, array $configuration, $plugin_id, $plugin_definition): self {
    return new static(
      $configuration,
      $plugin_id,
      $plugin_definition,
      $container->get('entity_type.manager')
    );
  }

  /**
   * {@inheritdoc}
   */
  public function clone(GroupContentInterface $group_content, string $group_clone_id, string $clone_method, array &$cloned_entity_ids): void {
    $group_content_clone = $this->cloneEntity($group_content, $cloned_entity_ids, $clone_method, [
      'gid' => $group_clone_id,
    ]);
  }

}
